using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;

public class StateMachine : MonoBehaviour
{
    public Note currentNote;

    public void nextNote(int count) {
        currentNote = currentNote.Transitions[count].Target;
        setNote();
    }    

    public void setNote() {
        var dialogueBox = GetComponent<DialogueBox>();
        dialogueBox.setActor(currentNote.ActorName);
        dialogueBox.setText(currentNote.DialogueText);
        dialogueBox.setTransitions(currentNote.Transitions);
    }


    public class Note {
        public string ActorName;
        public string DialogueText;
        public Transition[] Transitions;

        public Note(string actor,string dialogue) {
            ActorName = actor;
            DialogueText = dialogue;
        }

        public Note(string actor,string dialogue,Transition[] noteTransitions) {
            ActorName = actor;
            DialogueText = dialogue;
            Transitions = noteTransitions;
        }
    }


    public class Transition {
        public string TransitionName;
        public Note Target;

        public Transition(string name,Note target){
            TransitionName = name;
            Target = target;
        }

    }
}